import type { CSSProperties } from 'vue';
import type { EditorStateConfig, Extension } from '@codemirror/state';
import { Compartment, EditorState } from '@codemirror/state';
import type { EditorViewConfig, ViewUpdate } from '@codemirror/view';
import { EditorView } from '@codemirror/view';
export interface CreateStateOptions extends EditorStateConfig {
    onChange(doc: string, viewUpdate: ViewUpdate): void;
    onUpdate(viewUpdate: ViewUpdate): void;
    onFocus(viewUpdate: ViewUpdate): void;
    onBlur(viewUpdate: ViewUpdate): void;
}
export declare const createEditorState: ({ onUpdate, onChange, onFocus, onBlur, ...config }: CreateStateOptions) => EditorState;
export declare const createEditorView: (config: EditorViewConfig) => EditorView;
export declare const destroyEditorView: (view: EditorView) => void;
export declare const createEditorCompartment: (view: EditorView) => {
    compartment: Compartment;
    run: (extension: Extension) => void;
};
export declare const createEditorExtensionToggler: (view: EditorView, extension: Extension) => (targetApply?: boolean) => void;
export declare const getEditorTools: (view: EditorView) => {
    focus: () => void;
    getDoc: () => string;
    setDoc: (newDoc: string) => void;
    reExtensions: (extension: Extension) => void;
    toggleDisabled: (targetApply?: boolean) => void;
    toggleIndentWithTab: (targetApply?: boolean) => void;
    setTabSize: (tabSize: number) => void;
    setPhrases: (phrases: Record<string, string>) => void;
    setPlaceholder: (value: string) => void;
    setStyle: (style?: CSSProperties) => void;
};
