import type { EditorState } from '@codemirror/state';
import type { EditorView, ViewUpdate } from '@codemirror/view';
export declare enum EventKey {
    Change = "change",
    Update = "update",
    Focus = "focus",
    Blur = "blur",
    Ready = "ready",
    ModelUpdate = "update:modelValue"
}
export declare const editorEvents: {
    change: (_value: string, _viewUpdate: ViewUpdate) => boolean;
    update: (_viewUpdate: ViewUpdate) => boolean;
    focus: (_viewUpdate: ViewUpdate) => boolean;
    blur: (_viewUpdate: ViewUpdate) => boolean;
    ready: (_payload: {
        view: EditorView;
        state: EditorState;
        container: HTMLDivElement;
    }) => boolean;
};
export declare const modelUpdateEvent: {
    "update:modelValue": (_value: string, _viewUpdate: ViewUpdate) => boolean;
};
export declare const events: {
    "update:modelValue": (_value: string, _viewUpdate: ViewUpdate) => boolean;
    change: (_value: string, _viewUpdate: ViewUpdate) => boolean;
    update: (_viewUpdate: ViewUpdate) => boolean;
    focus: (_viewUpdate: ViewUpdate) => boolean;
    blur: (_viewUpdate: ViewUpdate) => boolean;
    ready: (_payload: {
        view: EditorView;
        state: EditorState;
        container: HTMLDivElement;
    }) => boolean;
};
export type EditorEvents = typeof editorEvents;
export type Events = typeof events;
