import type { Plugin } from 'vue';
export type { Props } from './props';
export type { Events } from './events';
export { DEFAULT_CONFIG } from './config';
export declare const Codemirror: import("vue").DefineComponent<{
    modelValue: {
        type: StringConstructor;
        default: string;
    };
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: import("vue").PropType<import("vue").CSSProperties>;
    autoDestroy: {
        type: BooleanConstructor;
        default: undefined;
    };
    phrases: import("vue").PropType<Record<string, string>>;
    root: import("vue").PropType<ShadowRoot | Document>;
    extensions: import("vue").PropType<import("@codemirror/state").Extension | undefined>;
    selection: import("vue").PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
}, () => import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "update:modelValue": (_value: string, _viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
    change: (_value: string, _viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
    update: (_viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
    focus: (_viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
    blur: (_viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
    ready: (_payload: {
        view: import("@codemirror/view").EditorView;
        state: import("@codemirror/state").EditorState;
        container: HTMLDivElement;
    }) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    modelValue: {
        type: StringConstructor;
        default: string;
    };
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: import("vue").PropType<import("vue").CSSProperties>;
    autoDestroy: {
        type: BooleanConstructor;
        default: undefined;
    };
    phrases: import("vue").PropType<Record<string, string>>;
    root: import("vue").PropType<ShadowRoot | Document>;
    extensions: import("vue").PropType<import("@codemirror/state").Extension | undefined>;
    selection: import("vue").PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
}>> & {
    onChange?: ((_value: string, _viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    onUpdate?: ((_viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    onFocus?: ((_viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    onBlur?: ((_viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    onReady?: ((_payload: {
        view: import("@codemirror/view").EditorView;
        state: import("@codemirror/state").EditorState;
        container: HTMLDivElement;
    }) => any) | undefined;
    "onUpdate:modelValue"?: ((_value: string, _viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
}, {
    modelValue: string;
    autofocus: boolean;
    disabled: boolean;
    indentWithTab: boolean;
    autoDestroy: boolean;
}>;
export declare const install: Plugin;
declare const _default: {
    Codemirror: import("vue").DefineComponent<{
        modelValue: {
            type: StringConstructor;
            default: string;
        };
        autofocus: {
            type: BooleanConstructor;
            default: undefined;
        };
        disabled: {
            type: BooleanConstructor;
            default: undefined;
        };
        indentWithTab: {
            type: BooleanConstructor;
            default: undefined;
        };
        tabSize: NumberConstructor;
        placeholder: StringConstructor;
        style: import("vue").PropType<import("vue").CSSProperties>;
        autoDestroy: {
            type: BooleanConstructor;
            default: undefined;
        };
        phrases: import("vue").PropType<Record<string, string>>;
        root: import("vue").PropType<ShadowRoot | Document>;
        extensions: import("vue").PropType<import("@codemirror/state").Extension | undefined>;
        selection: import("vue").PropType<import("@codemirror/state").EditorSelection | {
            anchor: number;
            head?: number | undefined;
        } | undefined>;
    }, () => import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
        "update:modelValue": (_value: string, _viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
        change: (_value: string, _viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
        update: (_viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
        focus: (_viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
        blur: (_viewUpdate: import("@codemirror/view").ViewUpdate) => boolean;
        ready: (_payload: {
            view: import("@codemirror/view").EditorView;
            state: import("@codemirror/state").EditorState;
            container: HTMLDivElement;
        }) => boolean;
    }, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        modelValue: {
            type: StringConstructor;
            default: string;
        };
        autofocus: {
            type: BooleanConstructor;
            default: undefined;
        };
        disabled: {
            type: BooleanConstructor;
            default: undefined;
        };
        indentWithTab: {
            type: BooleanConstructor;
            default: undefined;
        };
        tabSize: NumberConstructor;
        placeholder: StringConstructor;
        style: import("vue").PropType<import("vue").CSSProperties>;
        autoDestroy: {
            type: BooleanConstructor;
            default: undefined;
        };
        phrases: import("vue").PropType<Record<string, string>>;
        root: import("vue").PropType<ShadowRoot | Document>;
        extensions: import("vue").PropType<import("@codemirror/state").Extension | undefined>;
        selection: import("vue").PropType<import("@codemirror/state").EditorSelection | {
            anchor: number;
            head?: number | undefined;
        } | undefined>;
    }>> & {
        onChange?: ((_value: string, _viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        onUpdate?: ((_viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        onFocus?: ((_viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        onBlur?: ((_viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        onReady?: ((_payload: {
            view: import("@codemirror/view").EditorView;
            state: import("@codemirror/state").EditorState;
            container: HTMLDivElement;
        }) => any) | undefined;
        "onUpdate:modelValue"?: ((_value: string, _viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    }, {
        modelValue: string;
        autofocus: boolean;
        disabled: boolean;
        indentWithTab: boolean;
        autoDestroy: boolean;
    }>;
    install: ((app: import("vue").App<any>, ...options: any[]) => any) & {
        install?: ((app: import("vue").App<any>, ...options: any[]) => any) | undefined;
    };
};
export default _default;
