import type { CSSProperties, ExtractPropTypes, PropType } from 'vue';
export declare const configProps: {
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: PropType<CSSProperties>;
    autoDestroy: {
        type: BooleanConstructor;
        default: undefined;
    };
    phrases: PropType<Record<string, string>>;
    root: PropType<ShadowRoot | Document>;
    extensions: PropType<import("@codemirror/state").Extension | undefined>;
    selection: PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
};
export declare const modelValueProp: {
    modelValue: {
        type: StringConstructor;
        default: string;
    };
};
export declare const props: {
    modelValue: {
        type: StringConstructor;
        default: string;
    };
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: PropType<CSSProperties>;
    autoDestroy: {
        type: BooleanConstructor;
        default: undefined;
    };
    phrases: PropType<Record<string, string>>;
    root: PropType<ShadowRoot | Document>;
    extensions: PropType<import("@codemirror/state").Extension | undefined>;
    selection: PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
};
export type ConfigProps = ExtractPropTypes<typeof configProps>;
export type Props = ExtractPropTypes<typeof props>;
export type PropKey = keyof Props;
